---
title: ':-moz-ui-valid'
slug: 'Web/CSS/:-moz-ui-valid'
tags:
  - CSS
  - CSS Selectors
  - 'CSS:Mozilla Extensions'
  - NeedsExample
  - NeedsMobileBrowserCompatibility
  - Non-standard
  - Pseudo-class
  - Reference
  - Selector
---
<div>{{CSSRef}}{{Non-standard_Header}}</div>

<p>The <code>:-moz-ui-valid</code> CSS <a href="/en-US/docs/Web/CSS/Pseudo-classes">pseudo-class</a> represents any validated form element whose value validates correctly based on its <a href="/en-US/docs/Web/Guide/HTML/Forms_in_HTML#Constraint_Validation">validation constraints</a>.</p>

<p>This pseudo-class is applied according to the following rules:</p>

<ul>
 <li>If the control does not have focus, and the value is valid, apply this pseudo-class.</li>
 <li>If the control has focus, and the value was valid (including empty) when it gained focus, apply this pseudo-class.</li>
 <li>If the control has focus, and the value was invalid when it gained focus, re-validate on every keystroke.</li>
 <li>If the element is required, the preceding rules apply only if the user has changed the value or attempted to submit the form.</li>
</ul>

<p>The result is that if the control was valid when the user started interacting with it, the validity styling is changed only when the user shifts focus to another control. However, if the user is trying to correct a previously-flagged value, the control shows immediately when the value becomes valid. Required items are flagged as invalid only if the user changes them or attempts to submit an unchanged invalid value.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">{{CSSSyntax}}</pre>

<h2 id="Specifications">Specifications</h2>

<p>Not part of any standard.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.selectors.-moz-ui-valid")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{CSSxRef(":valid")}}</li>
 <li>{{CSSxRef(":invalid")}}</li>
 <li>{{CSSxRef(":required")}}</li>
 <li>{{CSSxRef(":optional")}}</li>
 <li>{{CSSxRef(":-moz-ui-invalid")}}</li>
</ul>
